<template>
  <form class="change-name" @submit.prevent="onChangeName">
    <input
      type="text"
      placeholder="Nombre y Apellido"
      class="form-control input-sm"
      v-model="name"
      :class="{ error: formError }"
    />
    <button type="submit" class="btn btn-primary">Actualizar</button>
  </form>
</template>

<script>
import { ref } from "vue";
import * as Yup from "yup";
import { Auth } from "../../utils/firebase";
import { useStore } from "vuex";
import { reload } from "@firebase/auth";

export default {
  name: "ChangeName",
  setup() {
    const store = useStore();
    let name = ref("");
    let formError = ref(false);

    const schemaForm = Yup.object().shape({
      name: Yup.string().min(6, true).required(true),
    });

    const onChangeName = async () => {
      formError.value = false;
      console.log("Cambiando el nombre");
      console.log("nuevo nombre", name.value);

      try {
        await schemaForm.validate({ name: name.value }, { abortEarly: false });
        try {
          await Auth.currentUser.updateProfile({
            displayName: name.value,
          });
          store.dispatch("reloadUser");
        } catch (error) {
          console.log(error);
        }
      } catch (err) {
        err.inner.forEach((error) => {
          formError.value = error.message;
        });
      }
    };

    return {
      name,
      onChangeName,
      formError,
    };
  },
};
</script>

<style lang="scss" scoped>
.change-name {
  text-align: center;
}
input.error {
  border-color: #faa;
  background-color: #ffeded;
}

button {
  margin: 20px 0 0 0;
}
button:hover {
  background-color: #3ab025;
}
</style>
